use hibitset::{BitSet, BitSetNot};

use crate::{
    access::{Join, ParJoin},
    entity::Index,
};

use super::DistinctStorage;

pub struct AntiStorage<'a>(pub &'a BitSet);

impl<'a> DistinctStorage for AntiStorage<'a> {}

impl<'a> Join for AntiStorage<'a> {
    type Mask = BitSetNot<&'a BitSet>;
    type Type = ();
    type Value = ();

    fn open(self) -> (Self::Mask, ()) {
        (BitSetNot(self.0), ())
    }

    fn get(_: &mut (), _: Index) {}
}

impl<'a> ParJoin for AntiStorage<'a> {}
